-- luatexplainko-common.lua
-- copyright (c) 2009  Dohyun Kim <nomos@ktug.or.kr>
-- license: lppl (maintained)
--
-- $Id: luatexplainko-common.lua,v 1.22 2009/10/10 09:55:03 nomos Exp $
--
-- This work may be distributed and/or modified under the
-- conditions of the LaTeX Project Public License, either version 1.3c
-- of this license or (at your option) any later version.
-- The latest version of this license is in
-- http://www.latex-project.org/lppl.txt
-- and version 1.3c or later is part of all distributions of LaTeX
-- version 2006/05/20 or later.
--
-- Read LICENSE included in the package.

texio.write_nl("loading luatexplainko-common.lua ...")

luako = luako or {}

luako.cjkclass = {
    [0x2018] = 1, -- ‘
    [0x201C] = 1, -- “
    [0xFF08] = 1, -- （
    [0xFE35] = 1, -- （ vert
    [0x3014] = 1, -- 〔
    [0xFE39] = 1, -- 〔 vert
    [0xFF3B] = 1, -- ［
    [0xFE47] = 1, -- ［ vert
    [0xFF5B] = 1, -- ｛
    [0xFE37] = 1, -- ｛ vert
    [0x3008] = 1, -- 〈
    [0xFE3F] = 1, -- 〈 vert
    [0x300A] = 1, -- 《
    [0xFE3D] = 1, -- 《 vert
    [0x300C] = 1, -- 「
    [0xFE41] = 1, -- 「 vert
    [0x300E] = 1, -- 『
    [0xFE43] = 1, -- 『 vert
    [0x3010] = 1, -- 【 
    [0xFE3B] = 1, -- 【 vert
    [0x3001] = 2, -- 、
    [0xFE11] = 2, -- 、 vert
    [0xFF0C] = 2, -- ，
    [0xFE10] = 2, -- ， vert
    [0x2019] = 2, -- ’
    [0x201D] = 2, -- ”
    [0xFF09] = 2, -- ）
    [0xFE36] = 2, -- ） vert
    [0x3015] = 2, -- 〕
    [0xFE3A] = 2, -- 〕 vert
    [0xFF3D] = 2, -- ］
    [0xFE48] = 2, -- ］ vert
    [0xFF5D] = 2, -- ｝
    [0xFE38] = 2, -- ｝ vert
    [0x3009] = 2, -- 〉
    [0xFE40] = 2, -- 〉 vert
    [0x300B] = 2, -- 》
    [0xFE3E] = 2, -- 》 vert
    [0x300D] = 2, -- 」
    [0xFE42] = 2, -- 」 vert
    [0x300F] = 2, -- 』
    [0xFE44] = 2, -- 』 vert
    [0x3011] = 2, -- 】
    [0xFE3C] = 2, -- 】 vert
    [0x00B7] = 3, -- ·
    [0x30FB] = 3, -- ・
    [0xFF1A] = 3, -- ：
    [0xFE13] = 3, -- ： vert
    [0xFF1B] = 3, -- ；
    [0xFE14] = 3, -- ； vert
    [0x3002] = 4, -- 。
    [0xFE12] = 4, -- 。 vert
    [0xFF0E] = 4, -- ．
    [0x2015] = 5, --  ―
    [0x2026] = 5, -- …
    [0xFE19] = 5, -- … vert
    [0x2025] = 5, -- ‥
    [0xFE30] = 5, -- ‥ vert
    [0xFF1F] = 6, -- ？
    [0xFF01] = 6, -- ！
}

luako.inhibitxspcode = {
    [0x002D] = 0, -- - hyphen minus
    [0x003C] = 0, -- <
    [0x003E] = 1, -- >
    [0x00B0] = 1,
    [0x2015] = 0,
    [0x2018] = 2,
    [0x2019] = 1,
    [0x201C] = 2,
    [0x201D] = 1,
    [0x2026] = 0,
    [0xFE19] = 0,
    [0x2032] = 1,
    [0x2033] = 1,
    [0x3001] = 1,
    [0xFE11] = 1,
    [0x3002] = 1,
    [0xFE12] = 1,
    [0x3008] = 2,
    [0xFE3F] = 2,
    [0x3009] = 1,
    [0xFE40] = 1,
    [0x300A] = 2,
    [0xFE3D] = 2,
    [0x300B] = 1,
    [0xFE3E] = 1,
    [0x300C] = 2,
    [0xFE41] = 2,
    [0x300D] = 1,
    [0xFE42] = 1,
    [0x300E] = 2,
    [0xFE43] = 2,
    [0x300F] = 1,
    [0xFE44] = 1,
    [0x3010] = 2,
    [0xFE3B] = 2,
    [0x3011] = 1,
    [0xFE3C] = 1,
    [0x3012] = 2, -- 〒
    [0x3014] = 2,
    [0xFE39] = 2,
    [0x3015] = 1,
    [0xFE3A] = 1,
    [0x301C] = 0,
    [0xFF08] = 2,
    [0xFE35] = 2,
    [0xFF09] = 1,
    [0xFE36] = 1,
    [0xFF0C] = 1,
    [0xFE10] = 1,
    [0xFF0E] = 1,
    [0xFF1B] = 1,
    [0xFE14] = 1,
    [0xFF1F] = 1,
    [0xFF3B] = 2,
    [0xFE47] = 2,
    [0xFF3D] = 1,
    [0xFE48] = 1,
    [0xFF5B] = 2,
    [0xFE37] = 2,
    [0xFF5D] = 1,
    [0xFE38] = 1,
    [0xFFE5] = 0,
}

luako.postbreakpenalty = {
    [0x0023] = 500,
    [0x0024] = 500,
    [0x0025] = 500,
    [0x0026] = 500,
    [0x0028] = 10000,
    [0x003C] = 10000, -- <
    [0x005B] = 10000,
    [0x0060] = 10000,
    [0x2018] = 10000,
    [0x201C] = 10000,
    [0x3008] = 10000,
    [0xFE3F] = 10000,
    [0x300A] = 10000,
    [0xFE3D] = 10000,
    [0x300C] = 10000,
    [0xFE41] = 10000,
    [0x300E] = 10000,
    [0xFE43] = 10000,
    [0x3010] = 10000,
    [0xFE3B] = 10000,
    [0x3014] = 10000,
    [0xFE39] = 10000,
    [0xFF03] = 200,
    [0xFF04] = 200,
    [0xFF05] = 200,
    [0xFF06] = 200,
    [0xFF08] = 10000,
    [0xFE35] = 10000,
    [0xFF3B] = 10000,
    [0xFE47] = 10000,
    [0xFF40] = 10000,
    [0xFF5B] = 10000,
    [0xFE37] = 10000,
}

luako.prebreakpenalty = {
    [0x0021] = 10000,
    [0x0022] = 10000,
    [0x0027] = 10000,
    [0x0029] = 10000,
    [0x002A] = 500,
    [0x002B] = 500,
    [0x002C] = 10000,
    [0x002D] = 10000,
    [0x002E] = 10000,
    [0x002F] = 500,
    [0x003A] = 10000,
    [0x003B] = 10000,
    [0x003E] = 10000, -- >
    [0x003F] = 10000,
    [0x005D] = 10000,
    [0x00B4] = 10000,
    [0x00B7] = 10000, -- ·
    [0x2013] = 10000, -- –
    [0x2014] = 10000, -- —
    [0x2015] = 10000,
    [0x2019] = 10000,
    [0x201D] = 10000,
    [0x2025] = 250,
    [0xFE30] = 250,
    [0x2026] = 250,
    [0xFE19] = 250,
    [0x2212] = 200,
    [0x3001] = 10000,
    [0xFE11] = 10000,
    [0x3002] = 10000,
    [0xFE12] = 10000,
    [0x3005] = 10000,
    [0x3009] = 10000,
    [0xFE40] = 10000,
    [0x300B] = 10000,
    [0xFE3E] = 10000,
    [0x300D] = 10000,
    [0xFE42] = 10000,
    [0x300F] = 10000,
    [0xFE44] = 10000,
    [0x3011] = 10000,
    [0xFE3C] = 10000,
    [0x3015] = 10000,
    [0xFE3A] = 10000,
    [0x3041] = 150,
    [0x3043] = 150,
    [0x3045] = 150,
    [0x3047] = 150,
    [0x3049] = 150,
    [0x3063] = 150,
    [0x3083] = 150,
    [0x3085] = 150,
    [0x3087] = 150,
    [0x308E] = 150,
    [0x309B] = 10000,
    [0x309C] = 10000,
    [0x30A1] = 150,
    [0x30A3] = 150,
    [0x30A5] = 150,
    [0x30A7] = 150,
    [0x30A9] = 150,
    [0x30C3] = 150,
    [0x30E3] = 150,
    [0x30E5] = 150,
    [0x30E7] = 150,
    [0x30EE] = 150,
    [0x30F5] = 150,
    [0x30F6] = 150,
    [0x30FB] = 10000,
    [0x30FC] = 10000,
    [0xFF01] = 10000,
    [0xFF09] = 10000,
    [0xFE36] = 10000,
    [0xFF0B] = 200,
    [0xFF0C] = 10000,
    [0xFE10] = 10000,
    [0xFF0E] = 10000,
    [0xFF1A] = 10000,
    [0xFE13] = 10000,
    [0xFF1B] = 10000,
    [0xFE14] = 10000,
    [0xFF1D] = 200,
    [0xFF1F] = 10000,
    [0xFF3D] = 10000,
    [0xFE48] = 10000,
    [0xFF5D] = 10000,
    [0xFE38] = 10000,
}

luako.xspcode = {
    [0x0027] = 2,
    [0x0028] = 1,
    [0x0029] = 2,
    [0x002C] = 2,
    [0x002E] = 2,
    [0x003B] = 2,
    [0x005B] = 1,
    [0x005D] = 2,
    [0x0060] = 1,
}

luako.cjk_glue_spec = { [0] =
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 },
    {[0] = nil,	     nil,      nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 }, 
    {[0] = {.5,.5},  {.5,.5},  nil,	 {.25,.25},nil,	     {.5,.5},  {.5,.5},	 {.5,.5},  {.5,.5},  {.5,.5},  {.5,.5},  },
    {[0] = {.25,.25},{.25,.25},{.25,.25},{.5,.25}, {.25,.25},{.25,.25},{.25,.25},{.25,.25},{.25,.25},{.25,.25},{.25,.25},},
    {[0] = {.5,0},   {.5,0},   nil,	 {.75,.25},nil,	     {.5,0},   {.5,0},	 {.5,0},   {.5,0},   {.5,0},   {.5,0},	 },
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,      nil,      nil,      nil,      nil,	 },
    {[0] = {.5,.5},  {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 {.5,.5},  {.5,.5},  {.5,.5},  {.5,.5},	 },
    --
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 },
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 },
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 },
    {[0] = nil,	     {.5,.5},  nil,	 {.25,.25},nil,	     nil,      nil,	 nil,	   nil,	     nil,      nil,	 },
}

luako.latin_fullstop = {
    [0x2e] = 1,
    [0x21] = 2,
    [0x3f] = 2,
}

-- tex repalace and ligature

luako.tliglist = {
    {0x0027, 0x0027, 0x201D},    -- ''
    {0x002D, 0x002D, 0x2013},    -- --
    {0x0060, 0x0060, 0x201C},    -- ``
    {0x2013, 0x002D, 0x2014},    -- ---
    {0x2018, 0x2018, 0x201C},    -- ‘‘
    {0x2019, 0x2019, 0x201D},    -- ’’
}

luako.treplist = {
    [0x0027] = 0x2019, -- ' -> ’
    [0x0060] = 0x2018, -- ` -> ‘
}

-- font substitution

local undefaultoption = "+microtype;interlatincjk=1125;punctraise=940"

luako.kofont = {
    rm = { m  = { n  = {"file:UnBatang:interhangul=960;"..undefaultoption},
		  it = {"file:UnDotum:"..undefaultoption},
		  sl = {"file:UnBatang:fakeslant=170;interhangul=960;"..undefaultoption},},
	   bx = { n  = {"file:UnBatangBold:"..undefaultoption},
		  it = {"file:UnDotumBold:"..undefaultoption},
		  sl = {"file:UnBatangBold:fakeslant=170;"..undefaultoption},},},
    sf = { m  = { n  = {"file:UnDotum:"..undefaultoption},
		  it = {"file:UnBatang:interhangul=960;"..undefaultoption},
		  sl = {"file:UnDotum:fakeslant=170;"..undefaultoption},},
	   bx = { n  = {"file:UnDotumBold:"..undefaultoption},
		  it = {"file:UnBatangBold:"..undefaultoption},
		  sl = {"file:UnDotumBold:fakeslant=170;"..undefaultoption},},},
    tt = { m  = { n  = {"file:UnTaza","UnDotum"},
		  it = {"file:UnTaza:fakeslant=170","file:UnDotum:fakeslant=170"},
		  sl = {"file:UnTaza:fakeslant=170","file:UnDotum:fakeslant=170"},},
	   bx = { n  = {"file:UnTaza","UnDotum"},},},}

luako.jpfont = {
    rm = { m  = { n = {"file:otf-japanese-mincho:+microtype","file:UnBatang:"..undefaultoption},},
	   bx = { n = {"file:otf-japanese-gothic:+microtype","file:UnDotum:"..undefaultoption},},},
    sf = { m  = { n = {"file:otf-japanese-gothic:+microtype","file:UnDotum:"..undefaultoption},},
	   bx = { n = {"file:otf-japanese-mincho:+microtype","file:UnBatang:"..undefaultoption},},},
    tt = { m  = { n = {"file:otf-japanese-mincho","file:UnBatang"},},
	   bx = { n = {"file:otf-japanese-gothic","file:UnDotum"},},},}

luako.csfont = {
    rm = { m  = { n = {"file:gbsn00lp:+microtype","file:UnBatang:"..undefaultoption},},
	   bx = { n = {"file:gkai00mp:+microtype","file:UnDotum:"..undefaultoption},},},
    sf = { m  = { n = {"file:gkai00mp:+microtype","file:UnDotum:"..undefaultoption},},
	   bx = { n = {"file:gbsn00lp:+microtype","file:UnBatang:"..undefaultoption},},},
    tt = { m  = { n = {"file:gbsn00lp","file:UnBatang"},},
	   bx = { n = {"file:gkai00mp","file:UnDotum"},},},} 

luako.ctfont = {
    rm = { m  = { n = {"file:bsmi00lp:+microtype","file:UnBatang:"..undefaultoption},},
	   bx = { n = {"file:bkai00mp:+microtype","file:UnDotum:"..undefaultoption},},},
    sf = { m  = { n = {"file:bkai00mp:+microtype","file:UnDotum:"..undefaultoption},},
	   bx = { n = {"file:bsmi00lp:+microtype","file:UnBatang:"..undefaultoption},},},
    tt = { m  = { n = {"file:bsmi00lp","file:UnBatang"},},
	   bx = { n = {"file:bkai00mp","file:UnDotum"},},},} 

luako.ltfont = { lmr = "rm", lmss = "sf", lmtt = "tt" }

luako.setadhocfont = {}
luako.dotemphnode  = {}
luako.rubynode	   = {}
luako.ulinebox	   = {}

-- automatic josa selection

luako.josa_list = {
    --	  리을,   중성,   종성   
    [0xAC00] = {0xC774, 0xAC00, 0xC774}, -- 가 = 이, 가, 이   
    [0xC740] = {0xC740, 0xB294, 0xC740}, -- 은 = 은, 는, 은   
    [0xC744] = {0xC744, 0xB97C, 0xC744}, -- 을 = 을, 를, 을   
    [0xC640] = {0xACFC, 0xC640, 0xACFC}, -- 와 = 과, 와, 과    
    [0xC73C] = {-1,     -1,     0xC73C}, -- 으(로) =   ,  , 으 
    [0xC774] = {0xC774, -1,     0xC774}, -- 이(라) = 이,  , 이 
}

luako.josa_code = {
    [0x30]	= 3, -- 0
    [0x31]	= 1, -- 1
    [0x33]	= 3, -- 3
    [0x36]	= 3, -- 6
    [0x37]	= 1, -- 7
    [0x38]	= 1, -- 8
    [0x4C]	= 1, -- L
    [0x4D]	= 3, -- M
    [0x4E]	= 3, -- N
    [0x6C]	= 1, -- l
    [0x6D]	= 3, -- m
    [0x6E]	= 3, -- n
    [0xFB02]	= 1, -- ﬂ
    [0xFB04]	= 1, -- ﬄ
    ng		= 3,
    ap		= 3,
    up		= 3,
    at		= 3,
    et		= 3,
    it		= 3,
    ot		= 3,
    ut		= 3,
    ok		= 3,
    ic		= 3,
    le		= 1,
    ime		= 3,
    ine		= 3,
    ack		= 3,
    ick		= 3,
    oat		= 2,
    TEX		= 3, 
    -- else 2
}

-- microtype

luako.prot_list = { -- modified from mt-cmr.cfg
    [0x41] = {0.05,0.05}, -- A
    [0x46] = {0   ,0.05}, -- F
    [0x4A] = {0.05,0   }, -- J
    [0x4B] = {0   ,0.05}, -- K
    [0x4C] = {0   ,0.05}, -- L
    [0x54] = {0.05,0.05}, -- T
    [0x56] = {0.05,0.05}, -- V
    [0x57] = {0.05,0.05}, -- W
    [0x58] = {0.05,0.05}, -- X
    [0x59] = {0.05,0.05}, -- Y
    [0x6B] = {0   ,0.05}, -- k
    [0x72] = {0   ,0.05}, -- r
    [0x74] = {0   ,0.07}, -- t
    [0x76] = {0.05,0.05}, -- v
    [0x77] = {0.05,0.05}, -- w
    [0x78] = {0.05,0.05}, -- x
    [0x79] = {0.05,0.07}, -- y
    [0x30] = {0   ,0.05}, -- 0
    [0x31] = {0.1 ,0.2 }, -- 1
    [0x32] = {0.05,0.05}, -- 2
    [0x33] = {0.05,0.05}, -- 3
    [0x34] = {0.07,0.07}, -- 4
    [0x35] = {0   ,0.05}, -- 5
    [0x36] = {0   ,0.05}, -- 6
    [0x37] = {0.05,0.1 }, -- 7
    [0x38] = {0   ,0.05}, -- 8
    [0x39] = {0   ,0.05}, -- 9
    [0x2E] = {0   ,0.7 }, -- .
    [0x2C] = {0   ,0.5 }, -- ,
    [0x3A] = {0   ,0.5 }, -- :
    [0x3B] = {0   ,0.5 }, -- ;
    [0x21] = {0   ,0.1 }, -- !
    [0x3F] = {0   ,0.2 }, -- ?
    [0x40] = {0.05,0.05}, -- @
    [0x7E] = {0.2 ,0.25}, -- ~
    [0x25] = {0.05,0.05}, -- %
    [0x2A] = {0.3 ,0.3 }, -- *
    [0x2B] = {0.25,0.25}, -- +
    [0x28] = {0.3 ,0   }, -- (
    [0x29] = {0   ,0.3 }, -- )
    [0x2F] = {0.2 ,0.3 }, -- /
    [0x2D] = {0.4 ,0.5 }, -- -
    [0x2013] = {0.4 ,0.3 }, -- --
    [0x2014] = {0.3 ,0.2 }, -- ---
    [0x2018] = {0.5 ,0.7 }, -- `
    [0x2019] = {0.5 ,0.6 }, -- '
    [0x201C] = {0.3 ,0.4 }, -- ``
    [0x201D] = {0.3 ,0.4 }, -- ''
}

luako.expand_list = { -- microtype.cfg
    [0x41] = 0.5, -- A
    [0x61] = 0.7, -- a
    [0x42] = 0.7, -- B
    [0x62] = 0.7, -- b
    [0x43] = 0.7, -- C
    [0x63] = 0.7, -- c
    [0x44] = 0.5, -- D
    [0x64] = 0.7, -- d
    [0x45] = 0.7, -- E
    [0x65] = 0.7, -- e
    [0x46] = 0.7, -- F
    [0x47] = 0.5, -- G
    [0x67] = 0.7, -- g
    [0x48] = 0.7, -- H
    [0x68] = 0.7, -- h
    [0x4B] = 0.7, -- K
    [0x6B] = 0.7, -- k
    [0x4D] = 0.7, -- M
    [0x6D] = 0.7, -- m
    [0x4E] = 0.7, -- N
    [0x6E] = 0.7, -- n
    [0x4F] = 0.5, -- O
    [0x6F] = 0.7, -- o
    [0x50] = 0.7, -- P
    [0x70] = 0.7, -- p
    [0x51] = 0.5, -- Q
    [0x71] = 0.7, -- q
    [0x52] = 0.7, -- R
    [0x53] = 0.7, -- S
    [0x73] = 0.7, -- s
    [0x55] = 0.7, -- U
    [0x75] = 0.7, -- u
    [0x57] = 0.7, -- W
    [0x77] = 0.7, -- w
    [0x5A] = 0.7, -- Z
    [0x7A] = 0.7, -- z
    [0x32] = 0.7, -- 2
    [0x33] = 0.7, -- 3
    [0x36] = 0.7, -- 6
    [0x38] = 0.7, -- 8
    [0x39] = 0.7, -- 9
    [0xC6] = 0.5, -- Æ
    [0xE6] = 0.7, -- æ
    [0x0152] = 0.5, -- Œ
    [0x0153] = 0.7, -- œ
}

luako.hangingpunctuations = {
    [0x002C] = 1, -- ,
    [0x002E] = 1, -- . 
    [0x3001] = 1, -- 、
    [0x3002] = 1, -- 。
    [0xFF0C] = 1, -- ，
    [0xFF0E] = 1, -- ．
}
