-- $Id: luatexplainko-findfile.lua,v 1.1 2009/10/10 09:50:28 nomos Exp $
-- copyright (c) 2009  Dohyun Kim <nomos@ktug.or.kr>
-- license: lppl (maintained)
--
-- This work may be distributed and/or modified under the
-- conditions of the LaTeX Project Public License, either version 1.3c
-- of this license or (at your option) any later version.
-- The latest version of this license is in
-- http://www.latex-project.org/lppl.txt
-- and version 1.3c or later is part of all distributions of LaTeX
-- version 2006/05/20 or later.
--
-- Read LICENSE included in the package.

texio.write_nl("loading luatexplainko-findfile.lua ...")

--
-- file name under korean windows os 
--

local function getuniuhctable()
    luako.uhc2ucs = luako.uhc2ucs or dofile(kpse.find_file('luatexplainko-cp949.lua'))
    if not luako.ucs2uhc then
	luako.ucs2uhc = {}
	for i,v in pairs(luako.uhc2ucs) do luako.ucs2uhc[v] = i end
    end
end

luako.cp949_filename = function(name)
    return unicode.utf8.gsub(name,"[\161-\239\191\166]", -- 00A1..FFE6
	function(c)
	    if not luako.ucs2uhc then getuniuhctable() end
	    local n = luako.ucs2uhc[unicode.utf8.byte(c)]
	    if not n then return c end
	    return string.format("%c%c", math.floor(n/256), n%256)
	end)
end

callback.register('find_read_file', function(id,name)
	return luako.cp949_filename(name)
end)

callback.register('find_image_file',  luako.cp949_filename)

--
-- redefine kpse.find_file
--
local luako_find_file = kpse.find_file

kpse.find_file = function (filename, ...)
	local found = luako_find_file (filename, ...)
	if not found then
		found = luako_find_file(luako.cp949_filename(filename), ...)
	end
	return found
end

