-- luatexplainko-input.lua
-- copyright (c) 2009  Dohyun Kim <nomos@ktug.or.kr>
-- license: lppl (maintained)
--
-- $Id: luatexplainko-input.lua,v 1.3 2009/10/10 09:55:03 nomos Exp $
--
-- This work may be distributed and/or modified under the
-- conditions of the LaTeX Project Public License, either version 1.3c
-- of this license or (at your option) any later version.
-- The latest version of this license is in
-- http://www.latex-project.org/lppl.txt
-- and version 1.3c or later is part of all distributions of LaTeX
-- version 2006/05/20 or later.
--
-- Read LICENSE included in the package.

texio.write_nl("loading luatexplainko-input.lua ...")

luako.uhc2ucs = luako.uhc2ucs or dofile(kpse.find_file('luatexplainko-cp949.lua'))

callback.register('process_input_buffer', function(buffer)
    -- check if buffer is utf-8
    local t = string.gsub(buffer,"([%z\1-\127])","")
    t = string.gsub(t,"([\194-\223][\128-\191])","")
    t = string.gsub(t,"([\224-\239][\128-\191][\128-\191])","")
    t = string.gsub(t,"([\240-\244][\128-\191][\128-\191][\128-\191])","")
    if string.len(t) == 0 then return buffer end
    -- convert cp949 to utf8
    return string.gsub(buffer,"[\129-\253][\65-\254]",
        function(c)
            local euca,eucb = string.byte(c,1,2)
            local euc = euca*256 + eucb
            return unicode.utf8.char(luako.uhc2ucs[euc])
        end)
end)
